/*	Formatright  2009, ConnorMcLeod

	Info Rank is free software;
	you can redistribute it and/or modify it under the terms of the
	GNU General Public License as published by the Free Software Foundation.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Info Rank; if not, write to the
	Free Software Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA 02111-1307, USA.
*/

#include <amxmodx>
#include <csx>
#include <hamsandwich>
#include <chatcolor>

#define VERSION "0.2.0"

#define ENABLED_BY_DEFAULT	1

#define MAX_PLAYERS 32

new g_iOldRank[MAX_PLAYERS+1]

new g_bEnabled[MAX_PLAYERS+1]

new g_pCvarInfoRank

public plugin_init()
{
	register_plugin("Info Rank", VERSION, "ConnorMcLeod")
	register_dictionary("inforank.txt")

	g_pCvarInfoRank = register_cvar("amx_inforank", "1")

	RegisterHam(Ham_Spawn, "player", "Player_Spawn_Post", 1)

	register_clcmd("say /inforank", "ClientCommand_InfoRank", 0, "- enable/disable info rank messages")
	register_clcmd("say_team /inforank", "ClientCommand_InfoRank", 0, "- enable/disable info rank messages")
}

public Player_Spawn_Post(id)
{
	if(	g_bEnabled[id]
	&&	is_user_alive(id)
	&&	get_pcvar_num(id)	)
	{
		new mOsef[8], iRank, iOldRank
		iRank = get_user_stats(id, mOsef, mOsef)

		iOldRank = g_iOldRank[id]
		if(iOldRank == 0)
		{
			iOldRank = iRank
		}
		g_iOldRank[id] = iRank

		new iDiff = iOldRank - iRank

		if(iDiff > 0)
		{
			client_print_color(id, DontChange, "%L", id, "IR_GOOD", iDiff)	
		}
		else if(iDiff < 0)
		{
			client_print_color(id, Red, "%L", id, "IR_GOOD", iDiff)
		}
		client_print_color(id, Grey, "%L", id, "IR_RANK", iRank, get_statsnum())
	}
}

public ClientCommand_InfoRank(id)
{
	if( get_pcvar_num(g_pCvarInfoRank) )
	{
		if( (g_bEnabled[id] = !g_bEnabled[id]) )
		{
			client_cmd(id, ";setinfo _ir 1")
			client_print_color(id, DontChange, "%L", id, "IR_ENABLE")
		}
		else
		{
			client_cmd(id, ";setinfo _ir 0")
			client_print_color(id, Red, "%L", id, "IR_DISABLE")
		}
	}
	return PLUGIN_CONTINUE
}

public client_putinserver(id)
{
	new mOsef[8]
	g_iOldRank[id] = get_user_stats(id, mOsef, mOsef)

	new szEnable[2]
	get_user_info(id, "_ir", szEnable, 1)
	if(!szEnable[0])
	{
		g_bEnabled[id] = ENABLED_BY_DEFAULT
		return
	}

	if(szEnable[0]=='1')
	{
		g_bEnabled[id] = true
	}
	else
	{
		g_bEnabled[id] = false
	}
}	